Subject: Default values for view helpers based on context
Description

We should supply a mechanism in the "ViewHelperNode" which will merge the given parameters with certain default parameters.

The default parameters should be context dependent (However, we don't know yet how this might look like).

This would be helpful for numerous cases:

    -  <f3:uri.linkTo> -> "action", "controller", and "package" arguments could be supplied if no other parameter given
    -  Link parameters - we could realize something like "keepPIVars" with this feature
    -  <f3:image> tag - supplying default parameters for maxWidth, maxHeight, ...

Related issues:
related to TYPO3.Fluid - Feature # 3717: "Designators" for Form view helper Resolved 2009-06-22

History
#1 - 2009-04-17 10:26 - Bastian Waidelich

while writing some view helpers i realized again: we need a "private" context that is available in the view helpers.
instead of an array this could be a class with getters for current view, global settings, default arguments...
default arguments could be an array like:
array(
  array('\F3\Fluid\ViewHelpers\Format\DateViewHelper' => array(
    'format' => 'Y-m-d'
  ),
  array('\F3\Fluid\ViewHelpers\LinkViewHelper' => array(
    'package' => 'foo',
    'controller' => 'bar',
...

In prepareArguments() of the abstract view helpers, the default arguments could be taken into account.

#2 - 2009-04-23 17:23 - Sebastian Kurfuerst

I don't really know anymore the intention of this... We need to discuss this as soon as I am back (e.g. next tuesday) - Greets Sebastian :-)

#3 - 2009-04-23 17:45 - Bastian Waidelich

I don't really know anymore the intention of this

I still remember - it's a very neat feature. And it will be especially useful for TYPO3:
Then you can eg. specify via TypoScript that currencyViewHelper has a default format of '##,## €' in the german branch and '##.## $' in the
American..
In conjunction with this I thought of following:{object} could internally call some kind of "defaultViewHelper" which has an argument "escapeHtml".. So
you could enable htmlspecialchars for html templates and disable it for special setups.
Well, just a very rough idea..

#4 - 2009-05-14 12:02 - Sebastian Kurfuerst
- Category set to 444
- Target version set to 1.0.0 alpha 1

#5 - 2009-05-21 11:01 - Sebastian Kurfuerst
- Target version changed from 1.0.0 alpha 1 to 1.0
- Branch set to v4 + v5

#6 - 2009-07-27 11:14 - Robert Lemke
- Target version deleted (1.0)

#7 - 2010-03-15 16:37 - Sebastian Kurfuerst
- Status changed from New to Needs Feedback
- Priority changed from Should have to Could have

#8 - 2010-03-16 12:41 - Bastian Waidelich

What kind of feedback do you want? ;)

#9 - 2010-11-16 11:54 - Franz Koch

Bastian Waidelich wrote:

I don't really know anymore the intention of this

I still remember - it's a very neat feature. And it will be especially useful for TYPO3:
Then you can eg. specify via TypoScript that currencyViewHelper has a default format of '##,## €' in the german branch and '##.## $' in the
American..
In conjunction with this I thought of following:{object} could internally call some kind of "defaultViewHelper" which has an argument "escapeHtml"..
So you could enable htmlspecialchars for html templates and disable it for special setups.
Well, just a very rough idea..

I like that idea - especially the escape part, as I'm currently trying to render a plaintext mail content with Fluid and everything is rendered through HSC
:(. But default viewHelper arguments like format options should get injected differently then the escaping stuff. Escaping should depend on the
renderingContext, whereas the other options could be defined via TS (in v4 maybe via
tx_fluid.viewHelper.[packageKey].format.date.defaultArguments.format = d.m.Y).
This feature might especially be needed for widgets, which of course should be globally configurable, otherwise they don't make much sense IMO.

#10 - 2011-02-23 11:08 - Bastian Waidelich
- Tracker changed from Feature to Major Feature

#11 - 2011-05-05 18:27 - Sebastian Kurfuerst
- Category set to Core
- Status changed from Needs Feedback to New

#12 - 2011-05-05 18:31 - Sebastian Kurfuerst
- Tracker changed from Major Feature to Story

#13 - 2011-05-06 11:03 - Sebastian Kurfuerst
- Tracker changed from Story to Feature
